/*------------------------------------------------------
   FILE NAME   : rcc.c
   DESCRIPTION : rcc driver for stm32
   VERSION     : 0.0.0 (C)XiaomaGee
   AUTHOR      : XiaomaGee
   CREATE DATE : 2010-6-3
   MODIFY DATE :
   LOGS        :-\
   --------------------------------------------------------*/

//---------------- Include files ------------------------//

#include "..\include\hardware.h"
#include "..\include\rcc.h"


//---------------- Function Prototype -------------------//

static int initialize(void);

//---------------- Variable -----------------------------//

SYS_RCC_T rcc = {
	.initialize = initialize,
};


//-----------------Function------------------------------//

/*-------------------------------------------------------
   NAME       : initialize
   ENTRY  TYPE: void
   RETURN TYPE: void
   PURPOSE    : ---
   VERSION    : 0.0.0
   DESCRIPTION:
   CREATE DATE: ---
   LOGS       :
   ---------------------------------------------------------*/
static int
initialize(void)
{
	RCC->CR.B.HSEON = 1;              //Enable external high-speed clock

	while (!(RCC->CR.B.HSERDY == 1)) ;  //HSEʱǷȶ
	RCC->CFGR.B.HPRE = 0;             //AHBԤƵϵ// 0Ƶ
	RCC->CFGR.B.PPRE2 = 0;            //APB2ԤƵϵ//0Ƶ
	RCC->CFGR.B.PPRE1 = 4;            //APB1ԤƵϵ100HCLK 2Ƶ//APB1 36MHz
	RCC->CFGR.B.ADCPRE = 1;           //ADCԤƵϵ//01PCLK2 4ƵΪADCʱ
	RCC->CFGR.B.PLLSRC = 1;           //ѡHSEHSI/2ΪPLL//	1HSEʱΪPLLʱӡ
	RCC->CFGR.B.PLLXTPRE = 0;         //HSEƵΪPLL
	//0HSEƵ
	//1HSE 2Ƶ
	RCC->CFGR.B.PLLMUL = 7;           //PLLƵ//0111PLL 9Ƶ
	                                  //PLLCLK = 8MHz * 9 = 72 MHz
	RCC->CR.B.PLLON = 1;              //ʹPLL//
	while (!(RCC->CR.B.PLLRDY == 1)) ;  //PLLǷ׼//

	FLASH->ACR.B.LATENCY = 2;         //000ȴ״̬ 0 < SYSCLK < 24MHz
	                                  //001һȴ״̬ 24MHz < SYSCLK < 48MHz
	                                  //010ȴ״̬ 48MHz < SYSCLK < 72MHz

	RCC->CFGR.B.SW = 2;               //ѡPLLΪϵͳʱ//	10PLLΪϵͳʱӣ
	while (!(RCC->CFGR.B.SWS == 2)) ;  //PLLǷѾΪϵͳʱ//  10PLLΪϵͳʱӣ


	RCC->APB2ENR.B.IOPAEN = 1;      //Enable A clocks
	RCC->APB2ENR.B.IOPBEN = 1;      //Enable GPIOB clocks
	RCC->APB2ENR.B.IOPCEN = 1;      //Enable GPIOC clocks
	RCC->APB2ENR.B.IOPDEN = 1;      //Enable GPIOD clocks
	RCC->APB2ENR.B.IOPEEN = 1;      //Enable GPIOE clocks

	RCC->APB2ENR.B.AFIOEN = 1;

	RCC->APB2ENR.B.USART1EN = 1;    //Enable USART clocks
	RCC->AHBENR.B.FSMCEN = 1;         //Enable FSMC clocks

	RCC->APB1ENR.B.TIM3EN = 1;


	RCC->APB1ENR.B.DACEN = 1;

	return 0;
}

